#include "define.h"
#include "mode15k.h"


/* Text */


//.
static CRTCPARAM mode640x200_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
      800, 640, 640, 672, 768, 792,   525, 400, 400, 447, 450, 524,

// width height HPlr VPlr DblScn Intrlc Iratio
     640,   400,   1,   1,     1,     0,     0,

// dotclkHz  horzHz  vertHz(in 0.01)
   25200000,  31500,   6000
};



/* VGA */


//.
static CRTCPARAM mode640x240_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
      800, 640, 640, 672, 768, 792,   525, 480, 480, 481, 484, 524,

// width height HPlr VPlr DblScn Intrlc Iratio
     640,   480,   1,   1,     1,     0,     0,

// dotclkHz  horzHz  vertHz(in 0.01)
   25200000,  31500,   6000
};




/* VESA */

//.
static CRTCPARAM mode640x480_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
      800, 640, 640, 672, 768, 792,   525, 480, 480, 481, 484, 524,

// width height HPlr VPlr DblScn Intrlc Iratio
     640,   480,   1,   1,     0,     0,     0,

// dotclkHz  horzHz  vertHz(in 0.01)
   25200000,  31500,   6000
};


//.
static CRTCPARAM mode640x400_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
      800, 640, 640, 672, 768, 792,   525, 400, 400, 447, 450, 524,

// width height HPlr VPlr DblScn Intrlc Iratio
     640,   400,   1,   1,     0,     0,     0,

// dotclkHz  horzHz  vertHz(in 0.01)
   25200000,  31500,   6000
};

//.
static CRTCPARAM mode512x384_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
      640, 512, 512, 528, 568, 632,   806, 768, 768, 769, 774, 805,

// width height HPlr VPlr DblScn Intrlc Iratio
     512,   384,   1,   1,     1,     0,     0,

// dotclkHz  horzHz  vertHz(in 0.01)
   30950400,  48360,   6000
};


//.
static CRTCPARAM mode400x300_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
      520, 400, 400, 432, 464, 512,   630, 600, 600, 601, 604, 629,

// width height HPlr VPlr DblScn Intrlc Iratio
     400,   300,   0,   0,     1,     0,     0,

// dotclkHz  horzHz  vertHz(in 0.01)
   19656000,  37800,   6000
};


//.
static CRTCPARAM mode320x480_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
      400, 320, 320, 336, 368, 392,   525, 480, 480, 481, 484, 524,

// width height HPlr VPlr DblScn Intrlc Iratio
     320,   480,   1,   1,     0,     0,     0,

// dotclkHz  horzHz  vertHz(in 0.01)
   12600000,  31500,   6000
};

//.
static CRTCPARAM mode320x240_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
      400, 320, 320, 336, 368, 392,   525, 480, 480, 481, 484, 524,

// width height HPlr VPlr DblScn Intrlc Iratio
     320,   480,   1,   1,     1,     0,     0,

// dotclkHz  horzHz  vertHz(in 0.01)
   12600000,  31500,   6000
};


//.
static CRTCPARAM mode320x200_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
      400, 320, 320, 336, 368, 392,   525, 400, 400, 447, 450, 524,

// width height HPlr VPlr DblScn Intrlc Iratio
     320,   400,   1,   1,     1,     0,     0,

// dotclkHz  horzHz  vertHz(in 0.01)
   12600000,  31500,   6000
};


//.
static CRTCPARAM mode800x600_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
     1032, 800, 800, 848, 936,1024,   630, 600, 600, 601, 606, 629,

// width height HPlr VPlr DblScn Intrlc Iratio
     800,   600,   0,   0,     0,     0,     0,

// dotclkHz  horzHz  vertHz(in 0.01)
   39009600,  37800,   6000
};



//.
static CRTCPARAM mode1024x768_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
     1280,1024,1024,1040,1152,1272,   806, 768, 768, 769, 774, 805,

// width height HPlr VPlr DblScn Intrlc Iratio
    1024,   768,   1,   1,     0,     0,     0,

// dotclkHz  horzHz  vertHz(in 0.01)
   61900800,  48360,   6000
};




/* Add Custom Modes here */

//.
static CRTCPARAM mode384x224_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
      464, 384, 384, 400, 416, 456,   525, 448, 448, 466, 469, 524,

// width height HPlr VPlr DblScn Intrlc Iratio
     384,   224,   1,   1,     1,     0,     0,

// dotclkHz  horzHz  vertHz(in 0.01)
   14616000,  31500,   6000
};


//.
static CRTCPARAM mode256x240_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
      312, 256, 256, 272, 296, 304,   525, 480, 480, 481, 484, 524,

// width height HPlr VPlr DblScn Intrlc Iratio
     256,   240,   1,   1,     1,     0,     0,

// dotclkHz  horzHz  vertHz(in 0.01)
    9828000,  31500,   6000
};

//.
static CRTCPARAM mode864x240_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
     1008, 864, 864, 872, 968,1000,   525, 480, 480, 481, 484, 524,

// width height HPlr VPlr DblScn Intrlc Iratio
     864,   480,   1,   1,     1,     0,     0,

// dotclkHz  horzHz  vertHz(in 0.01)
   31752000,  31500,   6000
};

//.
static CRTCPARAM mode864x480_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
     1008, 864, 864, 872, 968,1000,   525, 480, 480, 481, 484, 524,

// width height HPlr VPlr DblScn Intrlc Iratio
     864,   480,   1,   1,     0,     0,     0,

// dotclkHz  horzHz  vertHz(in 0.01)
   31752000,  31500,   6000
};

//.
static CRTCPARAM mode368x280_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
      464, 368, 368, 392, 424, 456,   588, 560, 560, 561, 564, 587,

// width height HPlr VPlr DblScn Intrlc Iratio
     368,   280,   1,   1,     1,     0,     0,

// dotclkHz  horzHz  vertHz(in 0.01)
   16369920,  35280,   6000
};

//.
static CRTCPARAM mode368x224_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
      448, 368, 368, 384, 400, 440,   525, 448, 448, 466, 469, 524,

// width height HPlr VPlr DblScn Intrlc Iratio
     368,   224,   1,   1,     1,     0,     0,

// dotclkHz  horzHz  vertHz(in 0.01)
   14112000,  31500,   6000
};






SCRLIST ScrModeList[] = {
/* Text, VGA */
        { 640, 200, &mode640x200_60},

/* VESA, VGA */
        { 320, 200, &mode320x200_60},
        { 640, 240, &mode640x240_60},
        { 640, 480, &mode640x480_60},

/* Generic VESA modes */
        { 320, 240, &mode320x240_60},
        { 320, 480, &mode320x480_60},
        { 400, 300, &mode400x300_60},
        { 512, 384, &mode512x384_60},
        { 640, 400, &mode640x400_60},
        { 800, 600, &mode800x600_60},
        {1024, 768, &mode1024x768_60},

/* Custom VESA modes */
        { 384, 224, &mode384x224_60},
        { 256, 240, &mode256x240_60},
        { 864, 240, &mode864x240_60},
        { 864, 480, &mode864x480_60},
        { 368, 280, &mode368x280_60},
        { 368, 224, &mode368x224_60},
        {   0,   0, &mode640x480_60},
};
